scala.util

# Failure

###
Related Doc: package util

#### final case class Failure[+T](exception: Throwable) extends Try[T] with Product with Serializable

Source
  Try.scala

Linear Supertypes
Serializable, java.io.Serializable, Product, Equals, Try[T], AnyRef, Any
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Failure
2. Serializable
3. Serializable
4. Product
5. Equals
6. Try
7. AnyRef
8. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new Failure(exception: Throwable)

### Type Members

1. #### class WithFilter extends AnyRef

   We need a whole WithFilter class to honor the "doesn't create a new collection" contract even though it seems unlikely to matter much in a collection with max size 1.

   We need a whole WithFilter class to honor the "doesn't create a new collection" contract even though it seems unlikely to matter much in a collection with max size 1.

   Definition Classes
     Try

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Failure[T] to any2stringadd[Failure[T]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Failure[T], B)

   Implicit information
     This member is added by an implicit conversion from Failure[T] to ArrowAssoc[Failure[T]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @IntrinsicCandidate() @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

8. #### def ensuring(cond: (Failure[T]) ⇒ Boolean, msg: ⇒ Any): Failure[T]

   Implicit information
     This member is added by an implicit conversion from Failure[T] to Ensuring[Failure[T]] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

9. #### def ensuring(cond: (Failure[T]) ⇒ Boolean): Failure[T]

   Implicit information
     This member is added by an implicit conversion from Failure[T] to Ensuring[Failure[T]] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: Boolean, msg: ⇒ Any): Failure[T]

    Implicit information
      This member is added by an implicit conversion from Failure[T] to Ensuring[Failure[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean): Failure[T]

    Implicit information
      This member is added by an implicit conversion from Failure[T] to Ensuring[Failure[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

13. #### val exception: Throwable

14. #### def failed: Try[Throwable]

    Inverts this `Try`.

    Inverts this `Try`. If this is a `Failure`, returns its exception wrapped in a `Success`. If this is a `Success`, returns a `Failure` containing an `UnsupportedOperationException`.

    Definition Classes
      Failure → Try

15. #### def filter(p: (T) ⇒ Boolean): Try[T]

    Converts this to a `Failure` if the predicate is not satisfied.

    Converts this to a `Failure` if the predicate is not satisfied.

    Definition Classes
      Failure → Try

16. #### def flatMap[U](f: (T) ⇒ Try[U]): Try[U]

    Returns the given function applied to the value from this `Success` or returns this if this is a `Failure`.

    Returns the given function applied to the value from this `Success` or returns this if this is a `Failure`.

    Definition Classes
      Failure → Try

17. #### def flatten[U](implicit ev: <:<[T, Try[U]]): Try[U]

    Transforms a nested `Try`, ie, a `Try` of type `Try[Try[T]]`, into an un-nested `Try`, ie, a `Try` of type `Try[T]`.

    Transforms a nested `Try`, ie, a `Try` of type `Try[Try[T]]`, into an un-nested `Try`, ie, a `Try` of type `Try[T]`.

    Definition Classes
      Failure → Try

18. #### def foreach[U](f: (T) ⇒ U): Unit

    Applies the given function `f` if this is a `Success`, otherwise returns `Unit` if this is a `Failure`.

    Applies the given function `f` if this is a `Success`, otherwise returns `Unit` if this is a `Failure`.

    Note: If `f` throws, then this method may throw an exception.

    Definition Classes
      Failure → Try

19. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from Failure[T] to StringFormat[Failure[T]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

20. #### def get: T

    Returns the value from this `Success` or throws the exception if this is a `Failure`.

    Returns the value from this `Success` or throws the exception if this is a `Failure`.

    Definition Classes
      Failure → Try

21. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

22. #### def getOrElse[U >: T](default: ⇒ U): U

    Returns the value from this `Success` or the given `default` argument if this is a `Failure`.

    Returns the value from this `Success` or the given `default` argument if this is a `Failure`.

    Note:: This will throw an exception if it is not a success and default throws an exception.

    Definition Classes
      Try

23. #### def isFailure: Boolean

    Returns `true` if the `Try` is a `Failure`, `false` otherwise.

    Returns `true` if the `Try` is a `Failure`, `false` otherwise.

    Definition Classes
      Failure → Try

24. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

25. #### def isSuccess: Boolean

    Returns `true` if the `Try` is a `Success`, `false` otherwise.

    Returns `true` if the `Try` is a `Success`, `false` otherwise.

    Definition Classes
      Failure → Try

26. #### def map[U](f: (T) ⇒ U): Try[U]

    Maps the given function to the value from this `Success` or returns this if this is a `Failure`.

    Maps the given function to the value from this `Success` or returns this if this is a `Failure`.

    Definition Classes
      Failure → Try

27. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

28. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

29. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

30. #### def orElse[U >: T](default: ⇒ Try[U]): Try[U]

    Returns this `Try` if it's a `Success` or the given `default` argument if this is a `Failure`.

    Returns this `Try` if it's a `Success` or the given `default` argument if this is a `Failure`.

    Definition Classes
      Try

31. #### def recover[U >: T](rescueException: PartialFunction[Throwable, U]): Try[U]

    Applies the given function `f` if this is a `Failure`, otherwise returns this if this is a `Success`.

    Applies the given function `f` if this is a `Failure`, otherwise returns this if this is a `Success`. This is like map for the exception.

    Definition Classes
      Failure → Try

32. #### def recoverWith[U >: T](f: PartialFunction[Throwable, Try[U]]): Try[U]

    Applies the given function `f` if this is a `Failure`, otherwise returns this if this is a `Success`.

    Applies the given function `f` if this is a `Failure`, otherwise returns this if this is a `Success`. This is like `flatMap` for the exception.

    Definition Classes
      Failure → Try

33. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

34. #### def toOption: Option[T]

    Returns `None` if this is a `Failure` or a `Some` containing the value if this is a `Success`.

    Returns `None` if this is a `Failure` or a `Some` containing the value if this is a `Success`.

    Definition Classes
      Try

35. #### def transform[U](s: (T) ⇒ Try[U], f: (Throwable) ⇒ Try[U]): Try[U]

    Completes this `Try` by applying the function `f` to this if this is of type `Failure`, or conversely, by applying `s` if this is a `Success`.

    Completes this `Try` by applying the function `f` to this if this is of type `Failure`, or conversely, by applying `s` if this is a `Success`.

    Definition Classes
      Try

36. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

37. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

38. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

39. #### final def withFilter(p: (T) ⇒ Boolean): WithFilter

    Creates a non-strict filter, which eventually converts this to a `Failure` if the predicate is not satisfied.

    Creates a non-strict filter, which eventually converts this to a `Failure` if the predicate is not satisfied.

    Note: unlike filter, withFilter does not create a new Try. Instead, it restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

    As Try is a one-element collection, this may be a bit overkill, but it's consistent with withFilter on Option and the other collections.

    p

      the predicate used to test elements.

    returns

      an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this Try which satisfy the predicate `p`.

    Definition Classes
      Try
    Annotations
      @inline()

40. #### def →[B](y: B): (Failure[T], B)

    Implicit information
      This member is added by an implicit conversion from Failure[T] to ArrowAssoc[Failure[T]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from Try[T]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Failure[T] to any2stringadd[Failure[T]]

### Inherited by implicit conversion StringFormat from Failure[T] to StringFormat[Failure[T]]

### Inherited by implicit conversion Ensuring from Failure[T] to Ensuring[Failure[T]]

### Inherited by implicit conversion ArrowAssoc from Failure[T] to ArrowAssoc[Failure[T]]

### Ungrouped